Index: /code/branches/3DPacman_FS19/src/modules/pacman/CMakeLists.txt
===================================================================
--- /code/branches/3DPacman_FS19/src/modules/pacman/CMakeLists.txt	(revision 12303)
+++ /code/branches/3DPacman_FS19/src/modules/pacman/CMakeLists.txt	(revision 12304)
@@ -6,6 +6,7 @@
   PacmanPointAfraid.cc
   PacmanHUDinfo.cc
+  PacmanRandom.cc
+  PacmanRed.cc
   getShortestPath.cc
-  PacmanRandom.cc
 )
 
Index: /code/branches/3DPacman_FS19/src/modules/pacman/PacmanBrown.cc
===================================================================
--- /code/branches/3DPacman_FS19/src/modules/pacman/PacmanBrown.cc	(revision 12304)
+++ /code/branches/3DPacman_FS19/src/modules/pacman/PacmanBrown.cc	(revision 12304)
@@ -0,0 +1,211 @@
+	
+#include "PacmanBrown.h"
+
+#include "core/CoreIncludes.h"
+#include "BulletDynamics/Dynamics/btRigidBody.h"
+
+	
+	namespace orxonox{
+
+		RegisterClass(PacmanBrown);
+
+		PacmanBrown::PacmanBrown(Context* context) : PacmanGhost(context){
+
+        RegisterObject(PacmanBrown);
+          
+    }
+
+    /**
+    @brief
+        Method for creating a ghost through XML.
+    */
+    void PacmanBrown::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(PacmanBrown, XMLPort, xmlelement, mode);
+    }
+
+
+
+	void PacmanBrown::tick(float dt)
+    {
+        SUPER(PacmanGhost, tick, dt);
+
+        this->actuelposition = this->getPosition();
+        
+        //Stop, if target arrived
+        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
+                 this->ismoving = false;
+        }
+
+        //Move, if ghost hasn't arrived yet
+        if(this->ismoving){
+            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
+                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
+                move(dt, actuelposition, velocity);
+            }    
+            if(!(abs(this->actuelposition.x-target_x)<0.5)){
+                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
+                move(dt, actuelposition, velocity);
+            }
+        }
+        
+        //Check on which position the ghost has arrived and set new target
+        else{
+
+        	while(lockmove){};
+            lockmove = true;
+
+        	//do brown behavior
+        	//put everything needed here
+
+        	if((this->fleeing==true)&&(this->actuelposition!=(-215,10,-195))){
+            //if fleeing, then go to corner map if not already there
+        		fleeMode();
+        	}
+        	else{ // else go next to pacman
+
+        		if(absoluteDistance(this->pos, player.pos)<10){//no idea if 10 ok
+        	//if near player, flee away
+        	fleemode();
+        			}
+        		else{ //go to neighboor of player nearest to brown pacman
+
+        		//first find nearest neighboor point of player to brown pacman
+        		//we can maybe call getShortestPath recursively to do so
+
+player.pos.nearestneighboor=findPlayerNeighboorNearestToPacman(player.neighboors);
+//btw the array player.neighboor can be defined with a big list as we
+//already did several times for similar things
+
+        	Vector3 nextMove = getShortestPath(this->actuelposition, player.pos.nearestneighboor);
+        	setNewTargetBrown(nextMove);
+        		}
+
+        	}
+   
+        }
+        
+    }
+
+
+
+
+
+
+
+
+
+
+	int graphDistance(Vector3 start, Vector3 goal){
+
+        Vector3 differenceVector= Vector3(abs(goal.x-start.x), 0,abs(goal.z-start.z));
+
+        return differenceVector.x+differenceVector.z;
+    }
+
+	void setNewTargetBrown(Vector3 goalToGo){
+
+					this->target_x = goalToGo.x;
+                    this->target_z = goalToGo.z; 
+                    this->ismoving = true;
+	}
+
+
+
+	int absoluteDistance(Vector3 pos1, Vector3 pos2){
+
+
+		Vector3 diffVector;
+		diffVector.x=pos2-pos1;
+		diffVector.y=pos2-pos1; //should always be 0
+		diffVector.z=pos2-pos1;
+		int result = sqrt(diffVector.x²+diffVector.z²);
+		return result;
+	}
+
+
+	void fleeMode(){ //flees to corner of the map
+
+		Vector3 cornerPos = Vector3(-215,10,-195); //let's take this. We can still change
+		Vector3 nextMove = getShortestPath(this->actuelposition, cornerPos);
+		setNewTargetBrown(nextMove);
+
+		/*//while(this->actuelposition!=cornerPos){
+	
+		continue moving and each time find next point to go until
+		we reach the corner
+		}*/
+	}
+
+
+	Vector3 goAdjacentOfPlayer(Vector neighboorsOfPlayer[]){
+		//find ,nearest to brown, player neighboor 
+
+		int besTotDist=-1;
+		Vector3 curPos=this->pos;
+		Vector3  predPos;
+		Vector3 chosenNeighbor;
+
+		for(int i=0; i < 4; i++){
+			int totDist=0;
+
+			if(neighboorsOfPlayer[i]!=0){
+				while(curPos!=neighboorsOfPlayer[i]){
+
+					predPos=curPos;
+					curPos = getShortestPath(curPos, neighboorsOfPlayer[i]);
+					totDist+=graphDistance(curPos,predPos);
+
+				}
+			}
+
+			if(besTotDist==-1){
+				besTotDist=totDist;
+				chosenNeighbor=neighboorsOfPlayer[i];
+			}
+			else if(besTotDist>totDist){
+				besTotDist=totDist;
+				chosenNeighbor=neighboorsOfPlayer[i];
+			}
+		}
+		return chosenNeighbor;
+
+	}
+
+
+	Vector3 findPlayerNeighboorNearestToPacman(Vector3 neighboorArray[]){
+		//uh, i think it does the same think as the function above
+
+        Vector3 nextMove;
+        int distCost=-1;
+        for(int i=0; i < 4; i++){
+        	int totDist=0;
+        	Vector3 newCandidate=this->actuelposition;
+        	Vector3 predPos;
+
+            if(neighboorArray[i]!=NULL){
+                while(nextMove!=neighboorArray[i]){
+                	predPos=newCandidate;
+                	newCandidate=getShortestPath(newCandidate, neighboorArray[i]);
+                	totDist+=graphDistance(predPos, newCandidate);
+                    }
+
+                    if(distCost==-1){
+                distCost=totDist;
+                nextMove=gneighboorArray[i];
+                    }
+                    else if(totDist<distCost){
+                distCost=totDist;
+                nextMove=neighboorArray[i];
+                    }
+            }
+        }
+        return nextMove;
+
+    }
+
+}
+
+
+
+
Index: /code/branches/3DPacman_FS19/src/modules/pacman/PacmanBrown.h
===================================================================
--- /code/branches/3DPacman_FS19/src/modules/pacman/PacmanBrown.h	(revision 12304)
+++ /code/branches/3DPacman_FS19/src/modules/pacman/PacmanBrown.h	(revision 12304)
@@ -0,0 +1,40 @@
+#ifndef _PacmanBrown_H__
+#define _PacmanBrown_H__
+
+
+#include "PacmanGhost.h"
+//#include "getShortestPath.h"
+
+
+namespace orxonox {
+
+	class _OrxonoxExport PacmanBrown : public PacmanGhost{
+
+		public :
+			PacmanBrown(Context* context);
+
+			virtual void tick(float dt) override; //!< Defines which actions the AutonomousDrone has to take in each tick.
+
+  			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+
+  			void setNewTargetBrown(Vector3 goalToGo);
+
+  			void nextMove(Vector3 playerPos, Vector3 redPos);
+
+  			int graphDistance(Vector3 start, Vector3 goal);
+
+  			int absoluteDistance(Vector3 pos1, Vector3 pos2);
+
+  			void fleeMode();
+
+
+  			Vector3 goAdjacentOfPlayer(Vector neighboorsOfPlayer[]);
+  			//they both do the same -_-
+  			Vector3 findPlayerNeighboorNearestToPacman(Vector3 neighboorArray);
+
+
+	};
+
+}
+
+#endif 
Index: /code/branches/3DPacman_FS19/src/modules/pacman/PacmanGhost.cc
===================================================================
--- /code/branches/3DPacman_FS19/src/modules/pacman/PacmanGhost.cc	(revision 12303)
+++ /code/branches/3DPacman_FS19/src/modules/pacman/PacmanGhost.cc	(revision 12304)
@@ -34,4 +34,27 @@
 namespace orxonox
 {
+
+    //Check if there is a collision
+        bool findpos(Vector3 one, Vector3 other){
+       if((abs(one.x - other.x)<0.5) && (abs(one.y - other.y)<0.5) && (abs(one.z - other.z)<0.5)) return true;
+        return false;
+        }
+
+    //All positions in the map, see documentation
+     Vector3 possibleposition[67] = {Vector3(20,10,245),Vector3(215,10,245),Vector3(215,10,195),Vector3(185,10,195),Vector3(135,10,195), //0-4
+        Vector3(185,10,150),Vector3(135,10,150),Vector3(215,10,150),Vector3(215,10,105),Vector3(135,10,105), //5-9
+        Vector3(135,10,15),Vector3(135,10,-85),Vector3(215,10,-85),Vector3(135,10,-135),Vector3(215,10,-135), //10-14
+        Vector3(215,10,-195),Vector3(135,10,-195),Vector3(20,10,195),Vector3(-20,10,195),Vector3(-20,10,245), //15-19
+        Vector3(-215,10,245),Vector3(-215,10,195),Vector3(-185,10,195),Vector3(-135,10,195),Vector3(-70,10,195), //20-24
+        Vector3(70,10,195),Vector3(70,10,150),Vector3(20,10,150),Vector3(-20,10,150),Vector3(-70,10,150), //25-29
+        Vector3(-135,10,150),Vector3(-185,10,150),Vector3(-215,10,150),Vector3(-215,10,105),Vector3(-135,10,105), //30-34
+        Vector3(-70,10,105),Vector3(-20,10,105),Vector3(20,10,105),Vector3(70,10,105),Vector3(70,10,60), //35-39
+        Vector3(0,10,60),Vector3(-70,10,60),Vector3(-135,10,15),Vector3(-70,10,60),Vector3(0,10,15), //40-44
+        Vector3(70,10,15),Vector3(-70,10,-35),Vector3(-20,10,-35),Vector3(20,10,-35),Vector3(70,10,-35), //45-49
+        Vector3(70,10,-85),Vector3(20,10,-85),Vector3(-20,10,-85),Vector3(-70,10,-85),Vector3(-135,10,-85), //50-54
+        Vector3(-215,10,-85),Vector3(-215,10,-135),Vector3(-135,10,-135),Vector3(-70,10,-135),Vector3(-20,10,-135), //55-59
+        Vector3(20,10,-135),Vector3(70,10,-135),Vector3(20,10,-195),Vector3(-20,10,-195),Vector3(-135,10,-195), //60-64
+        Vector3(-215,10,-195),Vector3(0,10,-35)}; //65-66
+
     RegisterClass(PacmanGhost);
 
@@ -47,4 +70,5 @@
 
         this->velocity = Vector3(0, 0, 0);
+
         this->setCollisionType(CollisionType::Dynamic);
         
@@ -72,70 +96,7 @@
         Method for creating a ghost through XML.
     */
-    void PacmanGhost::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+     void PacmanGhost::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
         SUPER(PacmanGhost, XMLPort, xmlelement, mode);
-
-    }
-
-
-   /* //All positions in the map, see documentation
-    Vector3 possibleposition[] = {Vector3(20,10,245),Vector3(215,10,245),Vector3(215,10,195),Vector3(185,10,195),Vector3(135,10,195), //0-4
-        Vector3(185,10,150),Vector3(135,10,150),Vector3(215,10,150),Vector3(215,10,105),Vector3(135,10,105), //5-9
-        Vector3(135,10,15),Vector3(135,10,-85),Vector3(215,10,-85),Vector3(135,10,-135),Vector3(215,10,-135), //10-14
-        Vector3(215,10,-195),Vector3(135,10,-195),Vector3(20,10,195),Vector3(-20,10,195),Vector3(-20,10,245), //15-19
-        Vector3(-215,10,245),Vector3(-215,10,195),Vector3(-185,10,195),Vector3(-135,10,195),Vector3(-70,10,195), //20-24
-        Vector3(70,10,195),Vector3(70,10,150),Vector3(20,10,150),Vector3(-20,10,150),Vector3(-70,10,150), //25-29
-        Vector3(-135,10,150),Vector3(-185,10,150),Vector3(-215,10,150),Vector3(-215,10,105),Vector3(-135,10,105), //30-34
-        Vector3(-70,10,105),Vector3(-20,10,105),Vector3(20,10,105),Vector3(70,10,105),Vector3(70,10,60), //35-39
-        Vector3(0,10,60),Vector3(-70,10,60),Vector3(-135,10,15),Vector3(-70,10,60),Vector3(0,10,15), //40-44
-        Vector3(70,10,15),Vector3(-70,10,-35),Vector3(-20,10,-35),Vector3(20,10,-35),Vector3(70,10,-35), //45-49
-        Vector3(70,10,-85),Vector3(20,10,-85),Vector3(-20,10,-85),Vector3(-70,10,-85),Vector3(-135,10,-85), //50-54
-        Vector3(-215,10,-85),Vector3(-215,10,-135),Vector3(-135,10,-135),Vector3(-70,10,-135),Vector3(-20,10,-135), //55-59
-        Vector3(20,10,-135),Vector3(70,10,-135),Vector3(20,10,-195),Vector3(-20,10,-195),Vector3(-135,10,-195), //60-64
-        Vector3(-215,10,-195),Vector3(0,10,-35)}; //65-66*/
-
-    /**
-    @brief
-        Defines which actions the ghost has to take in each tick.
-    @param dt
-        The length of the tick.
-    */
-    void PacmanGhost::tick(float dt)
-    {
-        SUPER(PacmanGhost, tick, dt);
-
-        this->actuelposition = this->getPosition();
-        
-        //Stop, if target arrived
-        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
-                 this->ismoving = false;
-        }
-
-        //Move, if ghost hasn't arrived yet
-        if(this->ismoving){
-            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
-                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
-                move(dt, actuelposition, velocity);
-            }    
-            if(!(abs(this->actuelposition.x-target_x)<0.5)){
-                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
-                move(dt, actuelposition, velocity);
-            }
-        }
-
-    }
-
-
-    //Random choice of new target (not used in game, but useful)
-    void PacmanGhost::setnewTarget(int firstdec){
-        
-    	  decision = rand()%1;
-            switch(decision){
-                case 0:
-                    this->target_x = possibleposition[firstdec].x;
-                    this->target_z = possibleposition[firstdec].z; 
-                    this->ismoving = true;
-                    break;
-    		}
     }
 
@@ -164,5 +125,5 @@
         
         //Rotate ghost in the direction of movement 
-        if((abs(abs(velocity.x)-1)<0.1) && (abs(velocity.z-0)<0.1))
+        if((abs(abs(velocity.x)-1)<0.1) && (abs(velocity.z-0)<0.1)){
             if(velocity.x<0){
                  this->setOrientation(Quaternion(Radian(-1.57), Vector3(0, 1, 0)));  
@@ -171,5 +132,6 @@
                  this->setOrientation(Quaternion(Radian(1.57), Vector3(0, 1, 0)));  
             }
-        if((abs(abs(velocity.z)-1)<0.1) && (abs(velocity.x-0)<0.1))
+        }
+        if((abs(abs(velocity.z)-1)<0.1) && (abs(velocity.x-0)<0.1)){
             if(velocity.z<0){
                  this->setOrientation(Quaternion(Radian(3.14), Vector3(0, 1, 0)));  
@@ -178,12 +140,7 @@
                  this->setOrientation(Quaternion(Radian(0), Vector3(0, 1, 0)));  
             }
+        }
                      
      }
-    }
-
-    //Check if there is a collision
-    bool PacmanGhost::findpos(Vector3 one, Vector3 other){
-       if((abs(one.x - other.x)<0.5) && (abs(one.y - other.y)<0.5) && (abs(one.z - other.z)<0.5)) return true;
-        return false;
     }
 
@@ -213,3 +170,16 @@
         speed ++;
     }
+
+    Vector3 PacmanGhost::setPureArrayPos(Vector3 &posToSet){
+        //given that the position of a pacman is generally not "neat",
+        //we need to set it to the nearest point on the map
+        // if the pacman is not moving anymore, i.e. has reached a point
+        int i=0;
+        while(!(findpos(possibleposition[i], posToSet))){
+            i++;
+        }
+        return possibleposition[i];
+    }
+
+
 }
Index: /code/branches/3DPacman_FS19/src/modules/pacman/PacmanGhost.h
===================================================================
--- /code/branches/3DPacman_FS19/src/modules/pacman/PacmanGhost.h	(revision 12303)
+++ /code/branches/3DPacman_FS19/src/modules/pacman/PacmanGhost.h	(revision 12304)
@@ -38,4 +38,17 @@
 namespace orxonox {
 
+    extern Vector3 possibleposition[67];
+
+    extern bool findpos(Vector3 one, Vector3 other);
+
+
+    struct graphVertex;
+    void findNeighboorVertices(Vector3 actuelposition, graphVertex adjacentVertices[]);
+    void updateShortestDistanceToStart(graphVertex &vertex, graphVertex &neighboor);
+    graphVertex findNextVertexToConsider(graphVertex[]);
+
+    extern graphVertex listOfVertices[];
+
+
     class _OrxonoxExport PacmanGhost : public ControllableEntity
     {
@@ -44,19 +57,19 @@
             virtual ~PacmanGhost();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating an AutonomousDrone through XML.
-            virtual void tick(float dt); //!< Defines which actions the AutonomousDrone has to take in each tick.
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) ; //!< Method for creating an AutonomousDrone through XML.
+            //virtual void tick(float dt); //!< Defines which actions the AutonomousDrone has to take in each tick.
 
-            void move(float dt, Vector3 actuelposition, Vector3 velocity);
+            virtual void move(float dt, Vector3 actuelposition, Vector3 velocity);
             
-            void resetGhost();
+            virtual void resetGhost();
 
-            void changewith(PacmanGhost* otherghost);
-            void levelupvelo();
+            virtual void changewith(PacmanGhost* otherghost);
+            virtual void levelupvelo();
 
-            bool findpos(Vector3 one, Vector3 other);      
-            void changemovability();
+            //bool findpos(Vector3 one, Vector3 other);      
+            virtual void changemovability();
             bool dontmove = false;
 
-
+       
             int decision = 0; 
             Vector3 resetposition = Vector3(0,10,15);
@@ -70,25 +83,9 @@
             bool lockmove = false;
 
-            //All positions in the map, see documentation
-    Vector3 possibleposition[67] = {Vector3(20,10,245),Vector3(215,10,245),Vector3(215,10,195),Vector3(185,10,195),Vector3(135,10,195), //0-4
-        Vector3(185,10,150),Vector3(135,10,150),Vector3(215,10,150),Vector3(215,10,105),Vector3(135,10,105), //5-9
-        Vector3(135,10,15),Vector3(135,10,-85),Vector3(215,10,-85),Vector3(135,10,-135),Vector3(215,10,-135), //10-14
-        Vector3(215,10,-195),Vector3(135,10,-195),Vector3(20,10,195),Vector3(-20,10,195),Vector3(-20,10,245), //15-19
-        Vector3(-215,10,245),Vector3(-215,10,195),Vector3(-185,10,195),Vector3(-135,10,195),Vector3(-70,10,195), //20-24
-        Vector3(70,10,195),Vector3(70,10,150),Vector3(20,10,150),Vector3(-20,10,150),Vector3(-70,10,150), //25-29
-        Vector3(-135,10,150),Vector3(-185,10,150),Vector3(-215,10,150),Vector3(-215,10,105),Vector3(-135,10,105), //30-34
-        Vector3(-70,10,105),Vector3(-20,10,105),Vector3(20,10,105),Vector3(70,10,105),Vector3(70,10,60), //35-39
-        Vector3(0,10,60),Vector3(-70,10,60),Vector3(-135,10,15),Vector3(-70,10,60),Vector3(0,10,15), //40-44
-        Vector3(70,10,15),Vector3(-70,10,-35),Vector3(-20,10,-35),Vector3(20,10,-35),Vector3(70,10,-35), //45-49
-        Vector3(70,10,-85),Vector3(20,10,-85),Vector3(-20,10,-85),Vector3(-70,10,-85),Vector3(-135,10,-85), //50-54
-        Vector3(-215,10,-85),Vector3(-215,10,-135),Vector3(-135,10,-135),Vector3(-70,10,-135),Vector3(-20,10,-135), //55-59
-        Vector3(20,10,-135),Vector3(70,10,-135),Vector3(20,10,-195),Vector3(-20,10,-195),Vector3(-135,10,-195), //60-64
-        Vector3(-215,10,-195),Vector3(0,10,-35)}; //65-66
+        Vector3 getShortestPath(Vector3 start, Vector3 goal);
 
-        private:
-            void setnewTarget(int firstdec);
-            void setnewTarget(int firstdec, int seconddec);
-            void setnewTarget(int firstdec, int seconddec, int thirddec);
-            void setnewTarget(int firstdec, int seconddec, int thirddec, int fourthdec);
+        Vector3 setPureArrayPos(Vector3 &posToSet);
+
+            private:
     };
 
